[LeetCode#133]Clone Graph

The problem:

Clone an undirected graph. Each node in the graph contains a label and a list of its neighbors.


OJ's undirected graph serialization:

Nodes are labeled uniquely.

We use  # as a separator for each node, and  , as a separator for node label and each neighbor of the node.

 

As an example, consider the serialized graph {0,1,2#1,2#2,2}.

The graph has a total of three nodes, and therefore contains three parts as separated by #.

  1. First node is labeled as 0. Connect node 0 to both nodes 1 and 2.
  2. Second node is labeled as 1. Connect node 1 to node 2.
  3. Third node is labeled as 2. Connect node 2 to node 2 (itself), thus forming a self-cycle.

 

Visually, the graph looks like the following:

       1
      / \
     /   \
    0 --- 2
         / \
         \_/

 

 

My analysis:
The implementation pattern used in this problem is very classic in cloning a graph. 
The key idea: use a hash map to store and retrieve the copy of a node. <original, copy>
The basic idea is to use the invariant:
1. we dequeue a node from the queue, then we scan the node's neighbors. we check if the neighbor node has already been traversaled by using the "containKeys()" method. 
1.1 iff the node is in the hashmap, we would not make a copy for it.
1.2 iff the node is not in the hashmap, we make a copy for this neighbor node. Put the <neighbor_node, copy> into the hashmap and enqueue the neighbor node.
if (!map.containsKey(cur.neighbors.get(i))) {//this node has not been traversaled
        copy = new UndirectedGraphNode(cur.neighbors.get(i).label);
        map.put(cur.neighbors.get(i), copy);
        queue.offer(cur.neighbors.get(i));
}

Note1: we only enqueue nodes from neighbors list, which means all neighbors list of remaining nodes in the queue(until the dequeue) has not been copyed yet. Thus, for each current node's neghbor list, we need to fully copy it. 

for (int i = 0; i < cur.neighbors.size(); i++) {
    if (!map.containsKey(cur.neighbors.get(i))) {
    ...
    }
    map.get(cur).neighbors.add(map.get(cur.neighbors.get(i)));
}

Note2: to use the invariant, we need to make necessary preparation for it (dummy layer). we should suppose there is dummy layer copy the starting node, and then put it into hashmap and enqueue the starting node.

My solution:

public class Solution {
    public UndirectedGraphNode cloneGraph(UndirectedGraphNode node) {
        
        if (node == null)
            return null;
        
        HashMap<UndirectedGraphNode, UndirectedGraphNode> map = new HashMap<UndirectedGraphNode, UndirectedGraphNode> ();
        Queue<UndirectedGraphNode> queue = new LinkedList<UndirectedGraphNode> ();
        UndirectedGraphNode cur;
        
        UndirectedGraphNode copy = new UndirectedGraphNode(node.label);
        queue.offer(node);
        map.put(node, copy);
        
        while(!queue.isEmpty()) {
            cur = queue.poll();
            for (int i = 0; i < cur.neighbors.size(); i++) {
                if (!map.containsKey(cur.neighbors.get(i))) {//this node has not been traversaled
                    copy = new UndirectedGraphNode(cur.neighbors.get(i).label);
                    map.put(cur.neighbors.get(i), copy);
                    queue.offer(cur.neighbors.get(i));
                }
                map.get(cur).neighbors.add(map.get(cur.neighbors.get(i)));
            }
        }
        
        return map.get(node);
    }
}

 

转载于:https://www.cnblogs.com/airwindow/p/4220170.html

  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值